package base;

public abstract class Scientist {
    protected double salary;
    protected int seniority;

    public Scientist(double salary, int seniority) {
        this.salary = salary;
        this.seniority = seniority;
    }

    public double getSalary() {
        return salary;
    }

    public void setSalary(double salary) {
        this.salary = salary;
    }

    public int getSeniority() {
        return seniority;
    }

    public void setSeniority(int seniority) {
        this.seniority = seniority;
    }

    // Абстрактный метод вычисления надбавки
    public abstract double computeBonus();

    // Дополнительные методы
    public void hire() {
        System.out.println("Научный сотрудник принят на работу.");
    }

    public void fire() {
        System.out.println("Научный сотрудник уволен.");
    }

    public void transfer() {
        System.out.println("Научный сотрудник перемещён на новую должность.");
    }

    public void accrueSalary() {
        double bonus = computeBonus();
        double totalSalary = salary + bonus;
        System.out.println("Начислена зарплата: " + totalSalary +
                " (ставка: " + salary + ", надбавка: " + bonus + ")");
    }

    // Переопределение equals() и hashCode() для проверки уникальности
    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        Scientist scientist = (Scientist) o;
        return Double.compare(scientist.salary, salary) == 0 &&
                seniority == scientist.seniority;
    }

    @Override
    public int hashCode() {
        return java.util.Objects.hash(getClass(), salary, seniority);
    }
}
